import * as tslib_1 from "tslib";
import * as React from 'react';
import { ExampleCard, ComponentPage, PropertiesTableSet } from '@uifabric/example-app-base';
import './examples/ActivityItem.Example.scss';
import { ComponentStatus } from '../../demo/ComponentStatus/ComponentStatus';
import { ActivityItemStatus } from './ActivityItem.checklist';
import { ActivityItemBasicExample } from './examples/ActivityItem.Basic.Example';
import { ActivityItemPersonaExample } from './examples/ActivityItem.Persona.Example';
import { ActivityItemCompactExample } from './examples/ActivityItem.Compact.Example';
var ActivityItemBasicExampleCode = require('!raw-loader!office-ui-fabric-react/src/components/ActivityItem/examples/ActivityItem.Basic.Example.tsx');
var ActivityItemPersonaExampleCode = require('!raw-loader!office-ui-fabric-react/src/components/ActivityItem/examples/ActivityItem.Persona.Example.tsx');
var ActivityItemCompactExampleCode = require('!raw-loader!office-ui-fabric-react/src/components/ActivityItem/examples/ActivityItem.Compact.Example.tsx');
var ActivityItemPage = /** @class */ (function (_super) {
    tslib_1.__extends(ActivityItemPage, _super);
    function ActivityItemPage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ActivityItemPage.prototype.render = function () {
        return (React.createElement(ComponentPage, { title: 'ActivityItem', componentName: 'ActivityItem', exampleCards: React.createElement("div", null,
                React.createElement(ExampleCard, { title: 'Activity Items with Icons', code: ActivityItemBasicExampleCode },
                    React.createElement(ActivityItemBasicExample, null)),
                React.createElement(ExampleCard, { title: 'Activity Items with Personas', code: ActivityItemPersonaExampleCode },
                    React.createElement(ActivityItemPersonaExample, null)),
                React.createElement(ExampleCard, { title: 'Compact Activity Items', code: ActivityItemCompactExampleCode },
                    React.createElement(ActivityItemCompactExample, null))), propertiesTables: React.createElement(PropertiesTableSet, { sources: [
                    require('!raw-loader!office-ui-fabric-react/src/components/ActivityItem/ActivityItem.types.ts')
                ] }), overview: React.createElement("div", null,
                React.createElement("p", null, "ActivityItems represent individual units of a user's activity, such as making a comment, mentioning someone with an @mention, editing a document, or moving a file.")), bestPractices: React.createElement("div", null), dos: React.createElement("div", null,
                React.createElement("ul", null,
                    React.createElement("li", null, "Use a list of multiple ActivityItems to indicate a history of events relating to a single file, folder, user, or other entity. Alternatively, use a single ActivityItem to indicate the most recent event on an entity."),
                    React.createElement("li", null, "Group multiple similar events occuring near the same time into single ActivityItems."))), donts: React.createElement("div", null,
                React.createElement("ul", null,
                    React.createElement("li", null, "Use ActivityItems to render large amounts of body text, they are meant to be concise descriptions of a specific activity."))), isHeaderVisible: this.props.isHeaderVisible, componentStatus: React.createElement(ComponentStatus, tslib_1.__assign({}, ActivityItemStatus)) }));
    };
    return ActivityItemPage;
}(React.Component));
export { ActivityItemPage };
//# sourceMappingURL=ActivityItemPage.js.map