import * as tslib_1 from "tslib";
/* tslint:disable:no-unused-variable */
import * as React from 'react';
/* tslint:enable:no-unused-variable */
import { autobind } from '../../../Utilities';
import { DefaultButton } from 'office-ui-fabric-react/lib/Button';
import { FocusTrapZone } from 'office-ui-fabric-react/lib/FocusTrapZone';
import { Link } from 'office-ui-fabric-react/lib/Link';
import { TextField } from 'office-ui-fabric-react/lib/TextField';
import { Toggle } from 'office-ui-fabric-react/lib/Toggle';
import './FocusTrapZone.Box.Example.scss';
var BoxNoClickExample = /** @class */ (function (_super) {
    tslib_1.__extends(BoxNoClickExample, _super);
    function BoxNoClickExample(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            isToggled: false,
        };
        return _this;
    }
    BoxNoClickExample.prototype.render = function () {
        var _this = this;
        var isToggled = this.state.isToggled;
        return (React.createElement("div", null,
            React.createElement(DefaultButton, { description: 'Focuses inside the FocusTrapZone', onClick: this._onButtonClickHandler, text: 'Go to Trap Zone' }),
            (function () {
                if (isToggled) {
                    return (React.createElement(FocusTrapZone, { isClickableOutsideFocusTrap: true, forceFocusInsideTrap: false }, _this._internalContents()));
                }
                else {
                    return (React.createElement("div", null, _this._internalContents()));
                }
            })()));
    };
    BoxNoClickExample.prototype._internalContents = function () {
        var _this = this;
        var isToggled = this.state.isToggled;
        return (React.createElement("div", { className: 'ms-FocusTrapZoneBoxExample' },
            React.createElement(TextField, { label: 'Default TextField', placeholder: 'Input inside Focus Trap Zone', className: '' }),
            React.createElement(Link, { href: '', className: '' }, "Hyperlink inside FocusTrapZone"),
            React.createElement("br", null),
            React.createElement("br", null),
            React.createElement(Toggle, { componentRef: this._setRef, checked: isToggled, onChanged: this._onFocusTrapZoneToggleChanged, label: 'Focus Trap Zone', onText: 'On', offText: 'Off' }),
            (function () {
                if (isToggled) {
                    return (React.createElement(DefaultButton, { description: 'Exit Focus Trap Zone', onClick: _this._onExitButtonClickHandler, text: 'Exit Focus Trap Zone' }));
                }
            })()));
    };
    BoxNoClickExample.prototype._onButtonClickHandler = function () {
        this.setState({
            isToggled: true
        });
    };
    BoxNoClickExample.prototype._onExitButtonClickHandler = function () {
        this.setState({
            isToggled: false
        });
    };
    BoxNoClickExample.prototype._onFocusTrapZoneToggleChanged = function (isToggled) {
        var _this = this;
        this.setState({
            isToggled: isToggled
        }, function () { return _this._toggle.focus(); });
    };
    BoxNoClickExample.prototype._setRef = function (toggle) {
        this._toggle = toggle;
    };
    tslib_1.__decorate([
        autobind
    ], BoxNoClickExample.prototype, "_onButtonClickHandler", null);
    tslib_1.__decorate([
        autobind
    ], BoxNoClickExample.prototype, "_onExitButtonClickHandler", null);
    tslib_1.__decorate([
        autobind
    ], BoxNoClickExample.prototype, "_onFocusTrapZoneToggleChanged", null);
    tslib_1.__decorate([
        autobind
    ], BoxNoClickExample.prototype, "_setRef", null);
    return BoxNoClickExample;
}(React.Component));
export default BoxNoClickExample;
//# sourceMappingURL=FocusTrapZone.Box.Click.Example.js.map